import socket
import ssl


def _get_new_task_number(task_number = 1):
    while True:
        yield task_number
        task_number += 1


_task_number_generator = _get_new_task_number(1)


def _generate_new_task_number():
    return _task_number_generator.send(None)


class login:
    # [0]
        # result format: "k": key
    task_number = _generate_new_task_number()
    default_task_parameters = [0]


class register:
    task_number = _generate_new_task_number()
    default_task_parameters = [0]


class logout:
    task_number = _generate_new_task_number()
    default_task_parameters = [0]


class memory:
    # --- task parameters ---
    # [0, {}] -> asking for tasks
    # [0, 0] -> the server will return all labels of memory tasks, which reached their time limit.
        # result format: "l": list of all labels -> list(str)
    # [0, 0, 1] -> the server will return all labels of memory tasks
        # result format: "l": list_of_all_labels
    # [0, 1, {}] -> The client asks for specific information about a memory task. The client needs to give the label of the memory task
    # [0, 1, 0] -> The client will receive all information about the memory task:
        # result format: "l": label, "m": message, "r1" repeat, "r2" receiver, Optional("la": last_action), Optional("s1": start_point), Optional("s2": stop_point), Optional("t": time_point), Optional("f": frequence)
    # [0, 1, 1] -> The client will receive the information he gives as parameter in the following way:
        # result format: "information": given information -> str
    # [1] -> sending new task
    # [2, {}] -> editing tasks
    # [2, 0] -> The client has to give a label. After that the time point of the last action will get renewed. The server will return the outcome of the task and after that the new time point
    # [3, 0] -> The client has go give a label. The task with this label will get deleted then.

    task_number = _generate_new_task_number()

    get_all_time_reached_labels_task_parameters = [0, 0]
    get_all_labels_task_parameters = [0, 0, 1]
    get_all_information_about_task_task_parameters = [0, 1, 0]
    get_specific_information_about_task_task_parameters = [0, 1, 1]

    create_new_task_task_parameters = [1]

    delete_task_task_parameters = [3, 0]

    renew_last_action_task_parameters = [2, 0]

    default_task_parameters = get_all_time_reached_labels_task_parameters


class login_token:
    # --- task parameters ---
    # [0] login with token
        # parameters: token
        # result format: {"r": result, "k" key}
    # [1] asking for new token
        # parameters: (token) -> token means hear the old token as an optional argument. If it is set, the old token will get deleted
    # [2] delete token
        # parameters: token
    # [3] delete all tokens
        # parameters: None
    
    task_number = _generate_new_task_number()

    login_task_parameters = [0]
    get_new_token_task_parameters = [1]
    delete_token_task_parameters = [2]
    delete_all_tokens_task_parameters = [3]

    default_task_parameters = login_task_parameters


class rsync:
    # --- task parameters ---
    # [0] returns to client if the server is ready for rsync
    task_number = _generate_new_task_number()
    default_task_parameters = [0]